import logic.MODE
import logic.parsing_sites.FransabankSite
import org.junit.jupiter.api.AfterEach
import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.api.BeforeEach
import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import java.lang.StringBuilder

@DisplayName("Fransabank site page")
class FransabankSiteTest: BankSiteTest() {

    val outputAll = """ExchangeOffice(name=Головной офис, address=пр-т. Независимости, 95 A, 220012, currencies=[CurrencyCourse(type=USD, purchase=2.125, selling=2.129), CurrencyCourse(type=EUR, purchase=2.382, selling=2.392), CurrencyCourse(type=RUB_100, purchase=3.28, selling=3.295), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.135), CurrencyCourse(type=CNY_10, purchase=3.0, selling=3.25), CurrencyCourse(type=EUR_USD, purchase=1.121, selling=1.127), CurrencyCourse(type=USD_RUB, purchase=64.5, selling=65.3), CurrencyCourse(type=EUR_RUB, purchase=72.2, selling=73.2)])
ExchangeOffice(name=Управление корпоративных клиентов, address=ул. Кальварийская, 4, 220004, currencies=[CurrencyCourse(type=USD, purchase=2.125, selling=2.129), CurrencyCourse(type=EUR, purchase=2.382, selling=2.392), CurrencyCourse(type=RUB_100, purchase=3.28, selling=3.295), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.135), CurrencyCourse(type=CNY_10, purchase=3.0, selling=3.25), CurrencyCourse(type=EUR_USD, purchase=1.121, selling=1.127), CurrencyCourse(type=USD_RUB, purchase=64.5, selling=65.3), CurrencyCourse(type=EUR_RUB, purchase=72.2, selling=73.2)])
ExchangeOffice(name=Центр Банковских Услуг №1, address=ул. Домбровская, 9, 220140, currencies=[CurrencyCourse(type=USD, purchase=2.125, selling=2.129), CurrencyCourse(type=EUR, purchase=2.382, selling=2.392), CurrencyCourse(type=RUB_100, purchase=3.28, selling=3.295), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.135), CurrencyCourse(type=CNY_10, purchase=3.0, selling=3.25), CurrencyCourse(type=EUR_USD, purchase=1.121, selling=1.127), CurrencyCourse(type=USD_RUB, purchase=64.5, selling=65.3), CurrencyCourse(type=EUR_RUB, purchase=72.2, selling=73.2)])
ExchangeOffice(name=Центр Банковских Услуг №2, address=ул. Жиновича, 7, 220055 (ТЦ "Виталюр", 2 этаж), currencies=[CurrencyCourse(type=USD, purchase=2.125, selling=2.129), CurrencyCourse(type=EUR, purchase=2.382, selling=2.392), CurrencyCourse(type=RUB_100, purchase=3.28, selling=3.295), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.135), CurrencyCourse(type=CNY_10, purchase=3.0, selling=3.25), CurrencyCourse(type=EUR_USD, purchase=1.121, selling=1.127), CurrencyCourse(type=USD_RUB, purchase=64.5, selling=65.3), CurrencyCourse(type=EUR_RUB, purchase=72.2, selling=73.2)])
ExchangeOffice(name=Расчетно-кассовый центр № 14, address=ул. Кульман, 5-Б, 220100, currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=Центр Банковских Услуг №3, address=Минская обл., Смолевичский район, Китайско-Белорусский индустриальный парк "Великий камень", Пекинский пр-т, 18, 222210, currencies=[CurrencyCourse(type=USD, purchase=2.125, selling=2.129), CurrencyCourse(type=EUR, purchase=2.382, selling=2.392), CurrencyCourse(type=RUB_100, purchase=3.28, selling=3.295), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.135), CurrencyCourse(type=CNY_10, purchase=3.0, selling=3.25), CurrencyCourse(type=EUR_USD, purchase=1.121, selling=1.127), CurrencyCourse(type=USD_RUB, purchase=64.5, selling=65.3), CurrencyCourse(type=EUR_RUB, purchase=72.2, selling=73.2)])
ExchangeOffice(name=ПОВ №1, address=ул. Скрипникова, 15а (Универсам "Алми"), currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=ПОВ №2, address=ул. Голубева, 24а (ОДО "Виталюр"), currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=CNY_10, purchase=3.0, selling=3.25), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=ПОВ №3, address=ул. Нестерова, 49, currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=ПОВ №4, address=ул. Нестерова, 49, currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=ПОВ №5, address=пр-т. Победителей, 65 (ТЦ "Замок"), currencies=[CurrencyCourse(type=USD, purchase=2.118, selling=2.13), CurrencyCourse(type=EUR, purchase=2.375, selling=2.41), CurrencyCourse(type=RUB_100, purchase=3.25, selling=3.29), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=CNY_10, purchase=3.0, selling=3.25), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.13), CurrencyCourse(type=USD_RUB, purchase=64.5, selling=66.0)])
ExchangeOffice(name=ПОВ №6, address=ул. Жиновича, 7 (ТЦ "Виталюр", 1 этаж), currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=ПОВ №10, address=ул. Рафиева, 56 (ТЦ "Виталюр"), currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=ПОВ №11, address=ул. Уборевича, 144А (У-м "Чижовский двор"), currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=ПОВ №14, address=ул. Некрасова, 3а (магазин "Виталюр"), currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=ПОВ №15, address=ул. Мирошниченко, 3, currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=CNY_10, purchase=3.0, selling=3.25), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=ПОВ №16, address=Игуменский тр-т, 11 (ТЦ "Виталюр"), currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=ПОВ №18, address=ул. Козлова, 2, currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.14), CurrencyCourse(type=EUR, purchase=2.375, selling=2.405), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5)])
ExchangeOffice(name=ПОВ №8, address=г. Минск, просп. Победителей, 9 (1 этаж ТРЦ Galleria Minsk)., currencies=[CurrencyCourse(type=USD, purchase=2.118, selling=2.13), CurrencyCourse(type=EUR, purchase=2.375, selling=2.41), CurrencyCourse(type=RUB_100, purchase=3.25, selling=3.29), CurrencyCourse(type=UAH_100, purchase=6.5, selling=8.5), CurrencyCourse(type=PLN_10, purchase=5.2, selling=6.0), CurrencyCourse(type=GBP, purchase=2.3, selling=3.0), CurrencyCourse(type=CHF, purchase=1.9, selling=2.145), CurrencyCourse(type=CNY_10, purchase=3.0, selling=3.25), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.13), CurrencyCourse(type=USD_RUB, purchase=64.5, selling=66.0)])

    """.trimIndent()

    @BeforeEach
    fun setTestMode(){
        MODE = "TEST"
    }

    @AfterEach
    fun setDevMode() {
        MODE = "DEV"
    }

    @Test
    @DisplayName("should parse all exchange offices on page")
    fun parseAll() {
        val sb = StringBuilder()
        FransabankSite().loadAllExchangeData {
            //println(it)
            sb.append(it.toString()).append("\n")
        }
        //println(sb)
        assertEquals(outputAll, sb.toString(), "Parse data is not correct")
    }
}